/***************************************************************
 * stack.cc ---- modul of information cluster for stack class  *
 *              (C++ version)                                  *
 ***************************************************************/

#include <stdio.h>   // NULL
#include "stack.hh"  // stack header file
#include <fstream.h> // ifstream

// ----<>----//
/* push operation */
void Stack :: push(char element)
{
  link_list *tmp = new link_list;

  tmp->value = element;
  tmp->next = top;
  top = tmp;

  return;
}

// ----<char Stack :: pop()>----//
/* pop operation */
char Stack :: pop()
{
  if (top == NULL) return NULL;

  link_list *tmp = top;
  char ch = top->value; 
  top = top->next;
  delete tmp;

  return ch;
}

// ----<void Stack :: show()>----//
/* display on stdout all elements in a stack (in the order from top to bottom) */
void Stack :: show() 
{
  link_list *tmp = top;  
  while (tmp) {
    cout << tmp->value;
    tmp = tmp->next;
  };

  return;
}

// ----<link_list * Stack :: scan(char element)>----//
link_list * Stack :: scan(char element)
{
  link_list *tmp = top;  
  while (tmp && (tmp->value != element)) tmp = tmp->next;
  
  return (tmp);
} 

// ----<void Stack :: copy(Stack& to)>----//
/* copy all elements in a stack to another stack */
void Stack :: copy(Stack& to)
{
  if (this->top == to.top) return; // return if copy to itself  
  while (to.pop());        // free any space left 

  if (this->top == NULL) 
    return;

  link_list *tmp_from = this->top;
  link_list *tmp_to = to.top = new link_list;
  tmp_to->value = tmp_from->value;
  link_list *tmp = tmp_to;
  tmp_from = tmp_from->next;

  // copy elementwise from top to bottom
  while (tmp_from != NULL) {
    tmp->next = tmp_to = new link_list;
    (tmp = tmp_to)->value = tmp_from->value;
    tmp_from = tmp_from->next;
  };
  tmp->next = NULL;

  return;
}
    
  
  
